<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="用户id" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入用户id" />
      </el-form-item>
      <el-form-item label="企业id" prop="enterpriseId">
        <el-input v-model="formData.enterpriseId" placeholder="请输入企业id" />
      </el-form-item>
      <el-form-item label="企业名称" prop="enterpriseName">
        <el-input v-model="formData.enterpriseName" placeholder="请输入企业名称" />
      </el-form-item>
      <el-form-item label="所属行业" prop="industryId">
        <el-input v-model="formData.industryId" placeholder="请输入所属行业" />
      </el-form-item>
      <el-form-item label="所属部门" prop="deptName">
        <el-input v-model="formData.deptName" placeholder="请输入所属部门" />
      </el-form-item>
      <el-form-item label="所属职位" prop="positionId">
        <el-input v-model="formData.positionId" placeholder="请输入所属职位" />
      </el-form-item>
      <el-form-item label="职位名称" prop="positionName">
        <el-input v-model="formData.positionName" placeholder="请输入职位名称" />
      </el-form-item>
      <el-form-item label="在职开始日期" prop="startTime">
        <el-date-picker
          v-model="formData.startTime"
          type="date"
          value-format="x"
          placeholder="选择在职开始日期"
        />
      </el-form-item>
      <el-form-item label="在职结束时间" prop="endTime">
        <el-date-picker
          v-model="formData.endTime"
          type="date"
          value-format="x"
          placeholder="选择在职结束时间"
        />
      </el-form-item>
      <el-form-item label="工作内容" prop="content">
        <Editor v-model="formData.content" height="150px" />
      </el-form-item>
      <el-form-item label="业绩" prop="achievement">
        <el-input v-model="formData.achievement" placeholder="请输入业绩" />
      </el-form-item>
      <el-form-item label="薪酬" prop="pay">
        <el-input v-model="formData.pay" placeholder="请输入薪酬" />
      </el-form-item>
      <el-form-item label="薪酬类型" prop="payType">
        <el-select v-model="formData.payType" placeholder="请选择薪酬类型">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.MENDUNER_PAY_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="货币类型" prop="currencyType">
        <el-select v-model="formData.currencyType" placeholder="请选择货币类型">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.MENDUNER_CURRENCY_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="技能" prop="skillList">
        <el-input v-model="formData.skillList" placeholder="请输入技能" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getIntDictOptions, DICT_TYPE } from '@/utils/dict'
import { WorkExpApi, WorkExpVO } from '@/api/menduner/system/workexp'

/** 工作经历 表单 */
defineOptions({ name: 'WorkExpForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  userId: undefined,
  enterpriseId: undefined,
  enterpriseName: undefined,
  industryId: undefined,
  deptName: undefined,
  positionId: undefined,
  positionName: undefined,
  startTime: undefined,
  endTime: undefined,
  content: undefined,
  achievement: undefined,
  pay: undefined,
  payType: undefined,
  currencyType: undefined,
  skillList: undefined
})
const formRules = reactive({
  userId: [{ required: true, message: '用户id不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await WorkExpApi.getWorkExp(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as WorkExpVO
    if (formType.value === 'create') {
      await WorkExpApi.createWorkExp(data)
      message.success(t('common.createSuccess'))
    } else {
      await WorkExpApi.updateWorkExp(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    userId: undefined,
    enterpriseId: undefined,
    enterpriseName: undefined,
    industryId: undefined,
    deptName: undefined,
    positionId: undefined,
    positionName: undefined,
    startTime: undefined,
    endTime: undefined,
    content: undefined,
    achievement: undefined,
    pay: undefined,
    payType: undefined,
    currencyType: undefined,
    skillList: undefined
  }
  formRef.value?.resetFields()
}
</script>